/***************************************************************************
 *   Copyright (C) 2005-2007 by Christian Weilbach                         *
 *   christian_weilbach@web.de                                             *
 *   Copyright (C) 2007 by Antonio Aloisio                                 *
 *   gnuton@gnuton.org                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kbloggerlinkdialog.h"

#include <klineedit.h>
#include <qregexp.h>
KBloggerLinkDialog::KBloggerLinkDialog(QWidget *parent, const char *name)
    :KBloggerLinkDialogBlank(parent, name)
{
}

void KBloggerLinkDialog::setLinkName(const QString &linkName=0)
{ 
  if ( linkName.isEmpty() )
  	nameLineEdit->clear();
  else
  	nameLineEdit->setText(sanitize(linkName));
}


void KBloggerLinkDialog::addLinkSlot()
{
	if ( targetLineEdit->text().isEmpty() || nameLineEdit->text().isEmpty()) return;
	emit addLink( targetLineEdit->text(), nameLineEdit->text() );
	//targetLineEdit->setText("http://");
	//nameLineEdit->clear();
	close();
}

QString KBloggerLinkDialog::sanitize(const QString& dirtyString)
{
  QRegExp rx("<[-;!= #:\"/.a-zA-Z0-9]+>");
  QString cleanedString=dirtyString;
  return cleanedString.remove(rx);
}

#include "kbloggerlinkdialog.moc"
